﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ozeki
{
    public record OzHfDownloadEvent(OzHfDownloadEventType EventType, string Message, DateTime At)
    {
        internal static OzHfDownloadEvent Success(string message)
        {
            return new OzHfDownloadEvent(OzHfDownloadEventType.SUCCESS, message, DateTime.Now);
        }

        internal static OzHfDownloadEvent Error(string message)
        {
            return new OzHfDownloadEvent(OzHfDownloadEventType.ERROR, message, DateTime.Now);
        }

        internal static OzHfDownloadEvent Info(string message)
        {
            return new OzHfDownloadEvent(OzHfDownloadEventType.INFO, message, DateTime.Now);
        }

    }
}
