﻿namespace Ozeki
{
    public class OzHfDownloadParams
    {
        public string DownloadUrl { get; init; }
        public string? AccessToken { get; init; }
        public int ThreadNumber { get; init; }
        public bool ForceDownload { get; init; }
        public string OutputLocation { get; init; }
        public int NumberOfRetries { get; init; }
        public long? MaxDownloadSpeedInBits { get; init; }

        public OzHfDownloadParams(string downloadUrl, string? accessToken = null, int threadNumber = 5, bool forceDownload = false, string outputLocation = "C:\\AIModels", int numberOfTries = 20, long? maxDownloadSpeedInBits = null)
        {
            DownloadUrl = downloadUrl;
            AccessToken = accessToken;
            ThreadNumber = threadNumber;
            ForceDownload = forceDownload;
            OutputLocation = outputLocation;
            NumberOfRetries = numberOfTries;
            MaxDownloadSpeedInBits = maxDownloadSpeedInBits;
        }

        public OzHfDownloadParams(string downloadUrl) : this(downloadUrl, null, 5, false, "C:\\AIModels", 20, null)
        {
        }
    }
}