﻿namespace Ozeki
{
    internal class OzHfURLParser
    {
        bool _valid;
        bool _repo;
        string _id;
        string _filepath;
        public OzHfURLParser(string rawUrl)
        {
            string[] splitted;
            bool fromUrl = false;
            _valid = false;
            _repo = true;
            _id = "";
            _filepath = "";
            if(Uri.TryCreate(rawUrl, UriKind.Absolute, out var url))
            {
                if(url.Host != "huggingface.co" || url.Scheme != "https")
                {
                    return;
                }
                splitted = url.AbsolutePath.Trim('/').Split('/');
                fromUrl = true;
            }
            else
            {
                splitted = rawUrl.Split('?')[0].Trim('/').Split('/');
            }

            if (splitted.Length < 2)
            {
                return;
            }
            _id = splitted[0] + "/" + splitted[1];
            if (splitted.Length == 2 || splitted.Length == 4 && splitted[2] == "tree" && splitted[3] == "main")
            {
                _filepath = "";
            }
            else if (splitted.Length > 4 && (splitted[2] == "tree" || splitted[2] == "blob" || splitted[2] == "resolve") && splitted[3] == "main")
            {
                _filepath = String.Join("/", splitted[4..^0]);
                _repo = false;
            }
            else if (splitted.Length > 2 && !fromUrl)
            {
                _filepath = String.Join("/", splitted[2..^0]);
                _repo = false;
            }        
            else
            {
                return;
            }
            _valid = true;
            return;
        }

        public bool IsValid => _valid;
        public string Id => _id;
        public string FilePath => _filepath;
        public bool IsRepository => _repo; 
    }
}
