﻿namespace Ozeki
{
    internal class OzHfHTTPClient : HttpClient
    {
        private static OzHfHTTPClient _instance;
        private static readonly object _instanceLock = new object();

        private static readonly SocketsHttpHandler handler = new SocketsHttpHandler
        {
            PooledConnectionLifetime = TimeSpan.FromMinutes(5),
            ConnectTimeout = TimeSpan.FromSeconds(30),
        };

        private OzHfHTTPClient() : base(handler)
        {
            Timeout = TimeSpan.FromSeconds(30);
        }

        public static OzHfHTTPClient Get()
        {
            lock (_instanceLock)
            {
                if (_instance == null)
                {
                    _instance = new OzHfHTTPClient();
                }
            }
            return _instance;
        }
    }
}
